
/* ============================ Anneaux de Borrome - Alain Esculier - Mars 2016 ======================= */

#version 3.7;
global_settings { assumed_gamma 1.8 }  



#include "colors.inc"
#include "glass.inc"

   
 //Lights, camera
camera { orthographic   //   perspective //
         location  < 0,0,-100>
         direction <0,0,1>
         look_at   < 0,0, 0>  
         right 1*x    
         
       // rotate -1.5*y
       }

light_source { <-10, 15,-30> color rgb 1   }                     //   shadowless        anneaux sans relief
light_source { <5,-5, -30> color rgb 1 shadowless }              //    <5,-15, -30>     anneaux sans relief    sinon     <5,-5, -30>   
                                                                



background{ White*0.7   } //   Black}     //   White   } // 
// --------------------------------------- 

#macro tex(pigm)  texture { pigment { leopard
                                  color_map {
                                      [ 0.3  color red 1 green 0.85 blue 1]
                                      [ 0.2  color red 0.9 green 0.7 blue 0.9]
                                      [ 0.6  color red 0.8 green 0.3 blue 0.7]
                                      [ 0.8  color red 0.7 green 0 blue 0 filter 0.5]
                                       } // color_map

                                  scale 0.1
                                  } // fin pigment
             
                          finish { diffuse 0.2 ambient 0.4 reflection 0. roughness 0.01 specular 0. }
                         } // texture //
#end

#declare fn1=   finish { ambient 0.4 diffuse 0.7 reflection 0.  phong 0. phong_size 2 };  
#declare fn=   finish { ambient 0.6 diffuse 0.2 reflection 0.1  phong 0.8 phong_size 10 }; 
#macro tex(col,finition) texture{  pigment{ col}    finish { finition} }    #end
// ---------------------------------------

  
#macro pt(R,uu) <R*cos(uu),R*sin(uu), h*cos(3*uu+pi/3)/3 > #end  //   h*cos(6*uu+pi/3)/3 

//#declare r=0.13;            //   0.15;   // pour le pavage 
#declare h=0.4;  
#macro courbe(R,r) 
      union{  # local deb=pi/3;  #local fin=7*pi/3;  #local n=800;   #local pas=(fin-deb)/n;
             // #for(i,0,n,1)  cylinder{pt(R,deb+i*pas),pt(R,deb+(i+1)*pas),r }   sphere{ pt(R,deb+i*pas),r } #end  
             #for(i,0,n-1,1)  cylinder{pt(R,deb+i*pas),pt(R,deb+(i+1)*pas),r }  cylinder{pt(R,deb+(i+1/2)*pas),pt(R,deb+(i+3/2)*pas),r }  #end 
             cylinder{pt(R,deb+(n-1)*pas),pt(R,deb+n*pas),r }
            }
     #end       

#macro tr(tt,N,coef) translate N*R*<cos(tt),sin(tt),0>*(2/3+coef) #end
#declare coeff=2/3;  
#declare rot=0;    //  60;   //   
  
 
//#macro anneauBase(R,r)   

#macro anneaux(R,r,col1,col2,col3,finition)
  union { #local ann=   courbe(R,r);
         union { ann    tr(0,1,0)         tex(col1,finition)    }                                             
         union { ann      tr(2*pi/3,1,0)    tex(col2,finition)    }   
         union { ann     tr(-2*pi/3,1,0)   tex(col3,finition)   }  
      } 
#end
// --------------------------------------- 
   
//=================== un seul motif ==========
#declare R=1;     #declare r=0.13;  
object { anneaux(R,r,Red*1.1,Yellow*0.65,Blue,fn)   // fn1 et Yellow*0.9 // pour uni  sinon fn et  Yellow*0.65
                 scale 0.27 
                 rotate -z*30    //  rotate 50*x  
                 translate -0.05*y     
                       }
         
/*   */      
  /*
background{ White*0.8   } //   Black}     
//=================== pavage de borromee==========  
#declare R=1;     #declare r=0.13;          
#declare n=2;  #declare p=3.5;
union{    #declare ann=   courbe(R,r);
         #for(i,-n,n,1)         
                    union{ #for(j,-n,n,1)  
                               object{ ann tr(0,p*j+1,0) tr(-2*pi/3,p*i,0) translate <1.2*r,-0.6*r,0> tex(Red*1.,fn) }          //    Red*1.1    sans relief 
                                object{ ann tr(-2*pi/3,p*j+1,0)   tr(0,p*i,0) translate -1.4*r*y tex(Blue*1.1,fn) }  
                                object{ ann tr(2*pi/3,p*j+1,0)  tr(0,p*i,0)  tex(Green*0.5 ,fn) }  //    Yellow*0.6  // 1.1 sans relief 
                          #end }   // boucle j 
          #end // boucle i              
          
               
       scale 0.15              
       }
         
*/       
// === pour anneaux nous ==== mettre cos(6*uu) dans pt
  /*        
#declare n=2;  #declare p=3.5; 
 
     #declare R=1;     #declare r=0.1; 
     union{  #declare ann=   courbe(R,r); 
              #for(i,-n,n,1)         
                    union{ #for(j,-n,n,1) 
                               object{ ann rotate 0*z tr(0,p*j+1,0) tr(-2*pi/3,p*i,0) translate <1.2*r,-0.6*r,0> tex(Red*1.,fn1) }          //    Red*1.1    sans relief 
                                object{ ann rotate 60*z tr(-2*pi/3,p*j+1,0)   tr(0,p*i,0) translate -1.4*r*y tex(Blue*1.1,fn1) }  
                                object{ ann rotate -60*z tr(2*pi/3,p*j+1,0)  tr(0,p*i,0)  tex(Green*0.5 ,fn1) }  //    Yellow*0.6  // 1.1 sans relief 
                          #end }   // boucle j 
            #end // boucle i              
            scale 0.15              
          } 
     
          
                                
                                    
        */     
       text {                                                      
           ttf "timrom.ttf" "AE" 0.15, 0   pigment {White*0.4 }
           scale 0.06   rotate <-15,10,0>  translate <2.4,-3,-1>*0.15
         } 
            